export declare type ObserverCallback<T> = (data: T[]) => void;
export default class Observable<T = any> {
    private collect;
    private collect_intervall;
    private subscriber;
    private events;
    private timeout;
    constructor(collect?: boolean, collect_intervall?: number);
    /**
     * Creates Public API with subscribe and unsubscribe
     *
     * @returns {object}
     */
    getPublicApi(): {
        /**
         * Subscribe to Observable
         * @param {function} callback
         */
        subscribe: (callback: ObserverCallback<T>, one?: boolean) => void;
        /**
        * Subscribe fron Observable
        * @param {function} callback
        */
        unsubscribe: (callback: ObserverCallback<T>) => void;
    };
    /**
     * Sends data to all subscribers
     * @param data data to be sent
     */
    send(data: T): void;
}
